/*
  start of a generic gui Device
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */


#include <deviceWidgets/guiDevice.h>



GuiDevice::GuiDevice( QWidget *parent=0, 
 		      const char *name=0 ) : GuiDeviceCore(parent,name) {

  menuDescription=new MenuDescription("empty Menu");
 
  insertMenu("Attach",this,SLOT(attach()));
  insertMenu("Detach",this,SLOT(detach()));
  insertMenu("Configure",this,SLOT(configure()));
  
}


GuiDevice::~GuiDevice() {
  delete menuDescription;
}

void GuiDevice::insertMenu(char* text,QObject* receiver,const char* signal) {
  menuDescription->insertMenu(text,receiver,signal);
}


void GuiDevice::setDevice(OutputDevice* device) {
  menuDescription->setTitle(device->getNodeName());
  GuiDeviceCore::setDevice(device);
}


void GuiDevice::mousePressEvent ( QMouseEvent* mouseEvent) {
  if (mouseEvent->button() ==  RightButton) {
    cout << "RightButton"<<endl;
    KPopupMenu* popupMenu=createPopupMenu();
    popupMenu->move(mapToGlobal(QPoint(mouseEvent->x(),mouseEvent->y())));
    popupMenu->exec();
    delete popupMenu;
  }
}


void GuiDevice::selected() {
  cout << "selcted something"<<endl;
}


KPopupMenu* GuiDevice::createPopupMenu() {
  int i;
  int n;
  MenuEntry* entry;
  KPopupMenu* popupMenu=new KPopupMenu(menuDescription->getTitle());

  n=menuDescription->getElements();
  for(i=0;i<n;i++) {
    entry=menuDescription->getMenu(i);
    popupMenu->insertItem(entry->text,entry->receiver,entry->signal);
  }

  return popupMenu;
}


    



 

